package com.fp.persistence.pgeneral.trans;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENETRANSACTIONITEMPROCESS*/
@Embeddable
public class TgeneTransactionItemProcessKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="TRANSACTIONMODULE", nullable=false,updatable=false)

/**
* Modulo al que pertence la transaccion
*/
private String transactionmodule;

@Column(name="TRANSACTIONCODE", nullable=false,updatable=false)

/**
* Codigo de transaccion dentro del modulo
*/
private Integer transactioncode;

@Column(name="TRANSACTIONVERSION", nullable=false,updatable=false)

/**
* Version de transaccion
*/
private Integer transactionversion;

@Column(name="ITEMCODE", nullable=false,updatable=false)

/**
* Sequencia de items dentro de la transaccion
*/
private Integer itemcode;

@Column(name="SEQUENCE", nullable=false,updatable=false)

/**
* Secuencia del comando para el item
*/
private Integer sequence;

/**Contructor por defecto*/
public TgeneTransactionItemProcessKey(){}
/**Contructor de TgeneTransactionItemProcessKey
@param pTransactionmodule Modulo al que pertence la transaccion
@param pTransactioncode Codigo de transaccion dentro del modulo
@param pTransactionversion Version de transaccion
@param pItemcode Sequencia de items dentro de la transaccion
@param pSequence Secuencia del comando para el item
*/
public TgeneTransactionItemProcessKey(String pTransactionmodule,Integer pTransactioncode,Integer pTransactionversion,Integer pItemcode,Integer pSequence){
 transactionmodule=pTransactionmodule;
 transactioncode=pTransactioncode;
 transactionversion=pTransactionversion;
 itemcode=pItemcode;
 sequence=pSequence;
}
/**Obtiene el valor de transactionmodule
@return valor de transactionmodule*/
public String getTransactionmodule(){
  return transactionmodule;
}
/**Fija el valor de transactionmodule
@param pTransactionmodule nuevo Valor de transactionmodule*/
public void setTransactionmodule(String pTransactionmodule){
  transactionmodule=pTransactionmodule;
}

/**Obtiene el valor de transactioncode
@return valor de transactioncode*/
public Integer getTransactioncode(){
  return transactioncode;
}
/**Fija el valor de transactioncode
@param pTransactioncode nuevo Valor de transactioncode*/
public void setTransactioncode(Integer pTransactioncode){
  transactioncode=pTransactioncode;
}

/**Obtiene el valor de transactionversion
@return valor de transactionversion*/
public Integer getTransactionversion(){
  return transactionversion;
}
/**Fija el valor de transactionversion
@param pTransactionversion nuevo Valor de transactionversion*/
public void setTransactionversion(Integer pTransactionversion){
  transactionversion=pTransactionversion;
}

/**Obtiene el valor de itemcode
@return valor de itemcode*/
public Integer getItemcode(){
  return itemcode;
}
/**Fija el valor de itemcode
@param pItemcode nuevo Valor de itemcode*/
public void setItemcode(Integer pItemcode){
  itemcode=pItemcode;
}

/**Obtiene el valor de sequence
@return valor de sequence*/
public Integer getSequence(){
  return sequence;
}
/**Fija el valor de sequence
@param pSequence nuevo Valor de sequence*/
public void setSequence(Integer pSequence){
  sequence=pSequence;
}

/**Implementación de la comparación de TgeneTransactionItemProcessKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneTransactionItemProcessKey))return false;
  TgeneTransactionItemProcessKey that = (TgeneTransactionItemProcessKey) o;
  if (this.getTransactionmodule() == null || that.getTransactionmodule() == null){
      return false;
  }
  if (! this.getTransactionmodule().equals(that.getTransactionmodule())){
    return false;
  }
  if (this.getTransactioncode() == null || that.getTransactioncode() == null){
      return false;
  }
  if (! this.getTransactioncode().equals(that.getTransactioncode())){
    return false;
  }
  if (this.getTransactionversion() == null || that.getTransactionversion() == null){
      return false;
  }
  if (! this.getTransactionversion().equals(that.getTransactionversion())){
    return false;
  }
  if (this.getItemcode() == null || that.getItemcode() == null){
      return false;
  }
  if (! this.getItemcode().equals(that.getItemcode())){
    return false;
  }
  if (this.getSequence() == null || that.getSequence() == null){
      return false;
  }
  if (! this.getSequence().equals(that.getSequence())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneTransactionItemProcessKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getTransactionmodule() == null ? 0 : this.getTransactionmodule().hashCode());
    result = result * 37 + (this.getTransactioncode() == null ? 0 : this.getTransactioncode().hashCode());
    result = result * 37 + (this.getTransactionversion() == null ? 0 : this.getTransactionversion().hashCode());
    result = result * 37 + (this.getItemcode() == null ? 0 : this.getItemcode().hashCode());
    result = result * 37 + (this.getSequence() == null ? 0 : this.getSequence().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
